﻿using System;
using UnityEngine;
using GamepadInput;

public class PlayerInput : MonoBehaviour
{
    #region Fields
    [SerializeField]
    private GamePad.Index playerIndex;

    public Action<Vector2> OnLeftStickValueChanged;
    public Action OnAButtonDown;
    public Action OnXButtonDown;
    #endregion

    #region MonoBehaviour methods
    void Update()
    {
        if (OnLeftStickValueChanged != null)
        {
            OnLeftStickValueChanged(GamePad.GetAxis(GamePad.Axis.LeftStick, playerIndex));
        }

        if (GamePad.GetButtonDown(GamePad.Button.A, playerIndex) == true)
        {
            if (OnAButtonDown != null)
            {
                OnAButtonDown();
            }
        }

        if (GamePad.GetButtonDown(GamePad.Button.X, playerIndex) == true)
        {
            if (OnXButtonDown != null)
            {
                OnXButtonDown();
            }
        }
    }
    #endregion
}