﻿using UnityEngine;

public class EnergyOperatable : Operatable
{
    private float valueIncreasePerUpdate = 0.25f;
    private bool isStarted = false;
    private float value = 0f;

    public EnergyOperatable(Machine machine) : base(machine)
    {
    }

    public override void OnUpdate()
    {
        if (isStarted && machine.Interactable.m_Interactions.m_State != Interactions.State.Collected)
        {
            value += valueIncreasePerUpdate * Time.deltaTime;
            machine.Interactable.ChangeValue(value);

            if (value >= 1f)
            {
                machine.Interactable.ChangeState(Interactions.State.Collected);
            }
        }
    }

    public override void OnXButtonDown()
    {
        if (isStarted == true)
        {
            return;
        }

        if (machine.Interactable.m_Interactions.m_State == Interactions.State.Waiting)
        {
            machine.Interactable.ChangeState(Interactions.State.Active);
        }
        else if (machine.Interactable.m_Interactions.m_State == Interactions.State.Active)
        {
            machine.Interactable.ChangeState(Interactions.State.Waiting);
        }
    }

    public override void OnAButtonDown()
    {
        if (isStarted == false)
        {
            machine.HideEnergyButtons();
            machine.AnimateButtonClick();
            isStarted = true;
        }
    }

    public override void OnLeftStickValueChanged(Vector2 value)
    {

    }
}