﻿using UnityEngine;

public class HeightOperatable : Operatable
{
    private float valueDecreasePerUpdate = 0.2f;
    private float valueIncrementPerButtonDown = 0.05f;
    private float value;

    public HeightOperatable(Machine machine) : base(machine)
    {
        value = Random.Range(0f, 0.5f);

        // TODO: Target value listener? Acquire target value from somewhere else?
        machine.Interactable.ChangeValue(value);
    }

    public override void OnUpdate()
    {
        if (machine.Interactable.m_Interactions.m_State != Interactions.State.Active)
        {
            return;
        }

        value -= valueDecreasePerUpdate * Time.deltaTime;

        if (value < 0f)
        {
            value = 0f;
        }

        if (value > 1f)
        {
            value = 1f;
        }

        machine.Interactable.ChangeValue(value);
    }

    public override void OnXButtonDown()
    {
        if (machine.Interactable.m_Interactions.m_State == Interactions.State.Waiting)
        {
            machine.Interactable.ChangeState(Interactions.State.Active);
        }
        else if (machine.Interactable.m_Interactions.m_State == Interactions.State.Active)
        {
            machine.Interactable.ChangeState(Interactions.State.Collected);
        }
    }

    public override void OnAButtonDown()
    {
        if (machine.Interactable.m_Interactions.m_State == Interactions.State.Active)
        {
            value += valueIncrementPerButtonDown;
            machine.Interactable.ChangeValue(value);
            machine.AnimateButtonClick();
        }
    }

    public override void OnLeftStickValueChanged(Vector2 value)
    {

    }
}