﻿using UnityEngine;

public class PhaseOperatable : Operatable
{
    private float value;

    public PhaseOperatable(Machine machine) : base(machine)
    {
    }

    public override void OnUpdate()
    {

    }

    public override void OnXButtonDown()
    {
        if (machine.Interactable.m_Interactions.m_State == Interactions.State.Waiting)
        {
            machine.Interactable.ChangeState(Interactions.State.Active);
        }
        else if (machine.Interactable.m_Interactions.m_State == Interactions.State.Active)
        {
            machine.Interactable.ChangeState(Interactions.State.Waiting);
        }
    }

    public override void OnAButtonDown()
    {
        if (machine.Interactable.m_Interactions.m_State == Interactions.State.Active)
        {
            machine.Interactable.ChangeState(Interactions.State.Collected);
        }
    }

    public override void OnLeftStickValueChanged(Vector2 value)
    {
        this.value = Vector2.Angle(Vector2.right, value) / 180f;
        machine.Interactable.ChangeValue(this.value);
    }
}