﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class OrbsController : MonoBehaviour {

	public GameObject m_OrbPrefab;
	public LevelManager m_LevelManager;

	Color EnergyColor = new  Color(0.8f, 0.8f, 0.8f);
	Color HeightColor = Color.blue;
	Color LengthColor = Color.green;
	Color PhaseColor = new Color (0.76f, 0f, 1f); 

	float m_Space = 0.9f;
	float m_StartingPosX = -2.3f;
	public List<GameObject> orbs;

	int m_ActivatedEnergyCount = 0;
	// Use this for initialization
	void Start () {
		
	}
	
	// Update is called once per frame
	void Update () {
		
	}


	Color GetTypeColor(Interactions.Type type){
		Color c = Color.white;
		switch(type){
		case Interactions.Type.Energy:
			c = EnergyColor;
			break;
		case Interactions.Type.Height:
			c = HeightColor;
			break;
		case Interactions.Type.Length:
			c = LengthColor;
			break;
		case Interactions.Type.Phase:
			c = PhaseColor;
			break;
		}
		return c;
	}

	GameObject InstantiateOrb(){
		return Instantiate (m_OrbPrefab, transform) as GameObject;
	}

	void OnLevelAssigned(Level lvl){

		m_ActivatedEnergyCount = 0;

		if (orbs.Count > 0) {
			foreach (var item in orbs) {
				item.SetActive (false);
			}
		}

		for (int i = 0; i < lvl.EnergyCount + 3; i++) {
			if (orbs.Count < i + 1) {
				orbs.Add (InstantiateOrb ());
				orbs [i].transform.localPosition = new Vector3 (m_StartingPosX + (i * m_Space), 0f, 0f);
			} else {
				orbs [i].SetActive (true);
			}
				
			if (i == 0) {
				orbs [i].GetComponent<OrbUI> ().Assign (GetTypeColor (Interactions.Type.Height));
			} else if (i == 1) {
				orbs [i].GetComponent<OrbUI> ().Assign (GetTypeColor (Interactions.Type.Length));
			} else if (i == 2) {
				orbs [i].GetComponent<OrbUI> ().Assign (GetTypeColor (Interactions.Type.Phase));
			} else {
				orbs [i].GetComponent<OrbUI> ().Assign (GetTypeColor (Interactions.Type.Energy));
			}
		}


	}

	void OnOrbDropped(Interactions.Type type){


		switch(type){
		case Interactions.Type.Energy:
			m_ActivatedEnergyCount++;
			orbs [2 + m_ActivatedEnergyCount].GetComponent<OrbUI> ().Fill ();
			break;
		case Interactions.Type.Height:
			orbs [0].GetComponent<OrbUI> ().Fill ();
			break;
		case Interactions.Type.Length:
			orbs [1].GetComponent<OrbUI> ().Fill ();
			break;
		case Interactions.Type.Phase:
			orbs [2].GetComponent<OrbUI> ().Fill ();
			break;
		}
	}

	void OnEnable(){
		m_LevelManager.OnLevelAssigned += OnLevelAssigned;
		m_LevelManager.OnOrbDropped += OnOrbDropped;
	}

	void OnDisable(){
		m_LevelManager.OnLevelAssigned -= OnLevelAssigned;
		m_LevelManager.OnOrbDropped -= OnOrbDropped;
	}
}
